import React from 'react';
import { storiesOf } from '@storybook/react';
import { action } from '@storybook/addon-actions';
import IconSettings from '../../icon-settings';
import { DATA_TABLE } from '../../../utilities/constants';
import Advanced from '../__examples__/advanced';
import AdvancedHeaderRow from '../__examples__/advanced-header-row';
import AdvancedSingleSelect from '../__examples__/advanced-single-select';
import AdvancedSingleSelectFixedHeader from '../__examples__/advanced-single-select-fixed-header';
import BasicFixedLayout from '../__examples__/basic-fixed-layout';
import BasicFluid from '../__examples__/basic-fluid';
import BasicFluidColumnBordered from '../__examples__/basic-fluid-column-bordered';
import BasicFluidNoRowHover from '../__examples__/basic-fluid-no-row-hover';
import BasicFluidStriped from '../__examples__/basic-fluid-striped';
import FixedHeader from '../__examples__/fixed-header';
import InteractiveElements from '../__examples__/interactive-elements';
import FixedHeaderHorizontalScroller from '../__examples__/fixed-header-horizontal-scrolling';
import JoinedWithPageHeader from '../__examples__/joined-with-page-header';
import CustomClasses from '../__examples__/custom-classes';
import InfiniteScrolling from '../__examples__/infinite-scrolling';
storiesOf(DATA_TABLE, module).addDecorator(function (getStory) {
  return /*#__PURE__*/React.createElement("div", {
    className: "slds-p-around_medium"
  }, /*#__PURE__*/React.createElement(IconSettings, {
    iconPath: "/assets/icons"
  }, getStory()));
}).add('Basic Fluid Layout (Default)', function () {
  return /*#__PURE__*/React.createElement(BasicFluid, null);
}).add('Basic Fluid Layout - Striped', function () {
  return /*#__PURE__*/React.createElement(BasicFluidStriped, null);
}).add('Basic Fluid Layout - No Row Hover', function () {
  return /*#__PURE__*/React.createElement(BasicFluidNoRowHover, null);
}).add('Basic Fluid Layout - Column Bordered', function () {
  return /*#__PURE__*/React.createElement(BasicFluidColumnBordered, null);
}).add('Basic Fixed Layout', function () {
  return /*#__PURE__*/React.createElement(BasicFixedLayout, null);
}).add('Advanced (Fixed Layout)', function () {
  return /*#__PURE__*/React.createElement(Advanced, {
    log: action
  });
}).add('Advanced Single Select (Fixed Layout)', function () {
  return /*#__PURE__*/React.createElement(AdvancedSingleSelect, {
    log: action
  });
}).add('Advanced Single Select (Fixed Header)', function () {
  return /*#__PURE__*/React.createElement(AdvancedSingleSelectFixedHeader, {
    log: action
  });
}).add('Advanced with Header Row', function () {
  return /*#__PURE__*/React.createElement(AdvancedHeaderRow, {
    log: action
  });
}).add('Fixed Header', function () {
  return /*#__PURE__*/React.createElement(FixedHeader, null);
}).add('Interactive Elements', function () {
  return /*#__PURE__*/React.createElement(InteractiveElements, null);
}).add('Fixed Header Horizontal Scrolling', function () {
  return /*#__PURE__*/React.createElement(FixedHeaderHorizontalScroller, null);
}).add('Joined with Page Header', function () {
  return /*#__PURE__*/React.createElement(JoinedWithPageHeader, null);
}).add('Custom Classes', function () {
  return /*#__PURE__*/React.createElement(CustomClasses, null);
}).add('Infinite Scrolling', function () {
  return /*#__PURE__*/React.createElement(InfiniteScrolling, null);
});
//# sourceMappingURL=storybook-stories.js.map